#include <iostream>

#include "soapH.h"

#include "ns.nsmap"

int http_get(struct soap *soap)
{
   FILE *fd = NULL;
   char *s = strchr(soap->path, '?');
   if (!s || strcmp(s, "?wsdl"))
      return SOAP_GET_METHOD;
   fd = fopen("ns.wsdl", "rb"); // open WSDL file to copy
   if (!fd)
      return 404; // return HTTP not found error
   soap->http_content = "text/xml"; // HTTP header with text/xml content
   soap_response(soap, SOAP_FILE);
   for (;;)
   {
      size_t r = fread(soap->tmpbuf, 1, sizeof(soap->tmpbuf), fd);
      if (!r)
         break;
      if (soap_send_raw(soap, soap->tmpbuf, r))
         break; // can't send, but little we can do about that
   }
   fclose(fd);
   soap_end_send(soap);
   return SOAP_OK; 
}

int main( int argc, char **argv )
{ 
	SOAP_SOCKET m, s; /* master and slave sockets */
	struct soap soap; /* structure soap */

	soap_init(&soap); // initialisation du serveur

	soap.fget = http_get;
	
	m = soap_bind( &soap, NULL, 8080, 100); // liaison avec le master socket 
	if ( !soap_valid_socket( m ) )
	{ 
		std::cout << "erreur de connection" << std::endl << "appuyez sur une touche pour quitter";
		std::cin.get();
		return 1;
	}

	// boucle principale
	std::cout << "connection russie: master socket = " << m << std::endl;
	for ( ; ; )
	{
		s = soap_accept( &soap );
		std::cout << "connection au client ok: slave socket = " << s << std::endl;
		if ( !soap_valid_socket( s ) )
		{ 
			std::cout << "erreur: problme de socket" << std::endl << "appuyez sur une touche pour quitter";
			return 1;
		} 
		soap_serve( &soap );
		soap_end( &soap );
	}

	return 0;
} 

// dfinition des oprations (dclares dans mon_cs.h)
// ici je n'en ai qu'une: op1
int ns__op1( struct soap *soap, int a, int b, int * r )
{ 
	std::cout << "op1 appel avec: a=" << a << ", b=" << b << std::endl;
	*r = 2 * a + b;
	return SOAP_OK;
} 